Skip to main content
`Ctrl`+`K`

# floyd_warshall_predecessor_and_distance

floyd_warshall_predecessor_and_distance(G, weight='weight')

  Find all-pairs shortest path lengths using Floyd’s algorithm.

  Parameters:
    G NetworkX graph
    weight: string, optional (default= ‘weight’)

      Edge data key corresponding to the edge weight.

  Returns:
    predecessor,distance dictionaries

      Dictionaries, keyed by source and target, of predecessors and distances in the shortest path.

  See also

  `floyd_warshall`
  `floyd_warshall_numpy`
  `all_pairs_shortest_path`
  `all_pairs_shortest_path_length`

  Notes

  Floyd’s algorithm is appropriate for finding shortest paths in dense graphs or graphs with negative weights when Dijkstra’s algorithm fails. This algorithm can still fail if there are negative cycles. It has running time \(O(n^3)\) with running space of \(O(n^2)\).

  Examples

      >>> G = nx.DiGraph()
      >>> G.add_weighted_edges_from(
      ...     [
      ...         ("s", "u", 10),
      ...         ("s", "x", 5),
      ...         ("u", "v", 1),
      ...         ("u", "x", 2),
      ...         ("v", "y", 1),
      ...         ("x", "u", 3),
      ...         ("x", "v", 5),
      ...         ("x", "y", 2),
      ...         ("y", "s", 7),
      ...         ("y", "v", 6),
      ...     ]
      ... )
      >>> predecessors, _ = nx.floyd_warshall_predecessor_and_distance(G)
      >>> print(nx.reconstruct_path("s", "v", predecessors))
      ['s', 'x', 'u', 'v']